#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>

#include"Lomb.h"

using namespace std;


int MAX_PIK=10000;
//int ndata=369589;
//int ndata=327604;
int ndata=52282;

int main()
{
    double *data, *jasnosc_oryg, *jasnosc_res, *blad;
    //ifstream in("AN2_STAR_0000000044_20071018T090143_20080303T094937_hel_lc.mag_det");
    ifstream in, in_config("config");
    //ifstream in("AN2_STAR_0000000044_20071018T090143_20080303T094937_hel_lc.mag_det2");
    ofstream out1, out2, out3, out4, out5;
    unsigned long jmax;
    double prob=0, hifac;
    double *px, *py, *a, *a_er;
    unsigned long nout;
    int pik1, pik, *ia, *ia1;
    double **covar, **alpha, chisq, alamda, chisq_old;
    string nazwa, lc_file, tmp_s;
    stringstream licznikStr;
    
    double flux_mean=0, tmp, noise;
    int noise_licznik;
    int if_only_last_v_fit=0;  
    int if_spec_window=0;
    
    in_config>>lc_file>>tmp_s;
    in_config>>MAX_PIK>>tmp_s;
    in_config>>ndata>>tmp_s;
    in_config>>hifac>>tmp_s;
    in_config>>if_only_last_v_fit>>tmp_s;
    in_config>>if_spec_window>>tmp_s;
    
    in_config.close();
    
    
  
    
    in.open(lc_file.c_str());
    
    out3.open("probability.dat");

    try
    {
        data=new double[ndata+1];
        jasnosc_oryg=new double[ndata+1];
	jasnosc_res=new double[ndata+1];
        blad=new double[ndata+1];
        px=new double[((int)hifac+1)*5*ndata+1];

        py=new double[((int)hifac+1)*5*ndata+1];
	a=new double[MAX_PIK*3+3];
	a_er=new double[MAX_PIK*3+3];
	ia=new int[MAX_PIK*3+3];
	ia1=new int[MAX_PIK*3+3];
    }
    catch (std::bad_alloc)
    {
        nrerror("Brak pamieci");
    }

/*    
    for(int i=1; i<=ndata; i++)
    {
        in>>data[i]>>jasnosc_oryg[i]>>blad[i]; 
	jasnosc_res[i]=jasnosc_oryg[i];
    }
*/
    for(int i=1; i<=ndata; i++)
    {
        in>>data[i]>>jasnosc_oryg[i]>>blad[i]>>tmp; 
       
        //blad[i]*=1000.; jasnosc_oryg[i]*=1000.;
	flux_mean+=jasnosc_oryg[i];
    }
    flux_mean/=ndata;
    
    cout<<"mag_mean "<<flux_mean<<endl;
    
    for(int i=1; i<=ndata; i++)
    {
        jasnosc_oryg[i]-=flux_mean;
	jasnosc_res[i]=jasnosc_oryg[i];
        //cout<<jasnosc_res[i]<<endl;
    }
    in.close();
    
    
    if(if_spec_window==1)
    {
        spec_wondow(data, jasnosc_res, ndata);
        exit(0);
    }

    
    
    for(pik=1, pik1=1; pik<=MAX_PIK; pik++, pik1+=3)
    {
      period(data, jasnosc_res, ndata, 8, hifac, px, py, hifac*5*ndata, &nout, &jmax, &prob);
            /*Given n data points with abscissas x[1..n] (which need not be equally spaced) and ordinates
              y[1..n], and given a desired oversampling factor ofac (a typical value being 4 or larger),
              this routine fills array px[1..np] with an increasing sequence of frequencies (not angular
              frequencies) up to hifac times the \average" Nyquist frequency, and fills array py[1..np]
              with the values of the Lomb normalized periodogram at those frequencies. The arrays x and y
              are not altered. np, the dimension of px and py, must be large enough to contain the output,
              or an error results. The routine also returns jmax such that py[jmax] is the maximum element
              in py, and prob, an estimate of the significance of that maximum against the hypothesis of
              random noise. A small value of prob indicates that a significant periodic signal is present.*/
	    
      
	    
      cout<<"*****************"<<endl<<"*****************"<<endl;
      
      noise=0;
      noise_licznik=0;
      for(int i=1; i<=nout; i++)
      {
          if(fabs(px[jmax]-px[i])<=0.5)
          {
              noise+=sqrt(4*py[i]/ndata);
              noise_licznik++;
          }
      }
      noise/=noise_licznik;
      
      cout<<scientific<<"nout "<<nout<<"  jmax "<<jmax<<"   prob "<<prob<<"    S/N  "<<sqrt(4*py[jmax]/ndata)/noise<<endl;
      out3<<scientific<<setw(5)<<setprecision(0)<<pik<<setw(35)<<setprecision(20)<<prob<<setw(14)<<setprecision(4)<<sqrt(4*py[jmax]/ndata)/noise<<endl;

      
      licznikStr<<fixed<<setw(3)<<setfill('0')<<setprecision(0)<<pik;
      nazwa="scargle"+licznikStr.str()+".dat";
      licznikStr.str("");
      out4.open(nazwa.c_str());
       for(int i=1; i<=nout; i++)
      {
          out4<<fixed<<setw(12)<<setprecision(8)<<px[i]<<setw(12)<<setprecision(4)<<1000.*sqrt(4*py[i]/ndata)<<endl;
          //py[i]=sqrt(4*py[i]/n);
      }
      out4.close();
 
      
      if(prob> 0.01) break;
      rob_rys(pik, px, py, jmax, nazwa);
    
     
      a[pik1+1]=px[jmax]; 
      ia[pik1]=1; ia[pik1+1]=1; ia[pik1+2]=1;
      
      
      covar=matrix(1,pik*3,1,pik*3);
      alpha=matrix(1,pik*3,1,pik*3);
    
      lindop(data, jasnosc_oryg, blad, ndata, a, a_er, pik, covar, &chisq);
      out3<<scientific<<"    chisq_lsq=  "<<setw(20)<<setprecision(4)<<chisq<<endl;
    
      out1.open("param_sin_lsqlin.dat", ios::app);
      //cout<<"#########################################"<<endl<<"------------------------------------------------"<<endl;
      for(int cc=1, licznik=1; cc<=pik1; cc+=3, licznik++)
      {
	//cout<< a[cc]<<" -- "<<a[cc+1]<<" -- "<<a[cc+2]<<" -- "<<chisq<<endl;
	out1<<fixed<<setw(5)<<setprecision(0)<<licznik<<setw(15)<<setprecision(10)<<a[cc+1]<<setw(15)<<setprecision(10)<<a[cc]<<setw(15)<<setprecision(10)<<a[cc+2];
	out1<<fixed<<setw(35)<<setprecision(10)<<a_er[cc]<<setw(15)<<setprecision(10)<<a_er[cc+2]<<endl;
      }
      //cout<<"------------------------------------------------"<<endl<<"#########################################"<<endl;
      out1<<endl;
      out1.close();
      

      
      alamda=-1;
      chisq_old=-1;
      ia1[pik1]=1; ia1[pik1+1]=1; ia1[pik1+2]=1;
      
      
      
      if(pik>1 && if_only_last_v_fit == 1)
      {
			for(int i=1; i<=pik1-1*3; i+=3)
			  ia1[i+1]=0;
      }


      while(1)
      {
        mrqmin(data, jasnosc_oryg, blad, ndata,  a, ia1, pik*3, covar, alpha, &chisq, ssinus, &alamda);
              // Levenberg-Marquardt method, attempting to reduce the value χ2 of a fit between a set of data
              // points x[1..ndata] , y[1..ndata] with individual standard deviations sig[1..ndata] ,
              // and a nonlinear function dependent on ma coefficients a[1..ma]. The input array ia[1..ma]
              // indicates by nonzero entries those components of a that should be fitted for, and by zero
              // entries those components that should be held fixed at their input values. The program re-
              // turns current best-fit values for the parameters a[1..ma], and χ2 = chisq. The arrays
              // covar[1..ma][1..ma] , alpha[1..ma][1..ma] are used as working space during most
              // iterations. Supply a routine funcs(x,a,yfit,dyda,ma) that evaluates the fitting function
              // yfit, and its derivatives dyda[1..ma] with respect to the fitting parameters a at x. On
              // the first call provide an initial guess for the parameters a, and set alamda<0 for initialization
              // (which then sets alamda=.001 ). If a step succeeds chisq becomes smaller and alamda de-
              // creases by a factor of 10. If a step fails alamda grows by a factor of 10. You must call this
              // routine repeatedly until convergence is achieved. Then, make one final call with alamda=0, so
              // that covar[1..ma][1..ma] returns the covariance matrix, and alpha the curvature matrix.
              // (Parameters held fixed will return zero covariances.) 
        if(fabs(chisq-chisq_old)<1e-6) break;
	chisq_old=chisq;
      }
    
      alamda=0;
      mrqmin(data, jasnosc_oryg, blad, ndata,  a, ia1, pik*3, covar, alpha, &chisq, ssinus, &alamda);
      out3<<scientific<<"    chisq_mrq=  "<<setw(20)<<setprecision(4)<<chisq<<endl;
      err_mrqmin(data, jasnosc_oryg, blad, ndata, a, a_er, pik*3, covar);
      
      out2.open("param_sin_mrqmin.dat", ios::app);
      for(int cc=1, licznik=1; cc<=pik1; cc+=3, licznik++)
      {
	  //cout<<a[cc]<<"  "<<a[cc+1]<<"  "<<a[cc+2]<<"  ++++++"<<alamda<<"  "<<setprecision(10)<<chisq<<endl;
	  out2<<fixed<<setw(5)<<setprecision(0)<<licznik<<setw(15)<<setprecision(9)<<a[cc+1]<<setw(15)<<setprecision(10)<<a[cc]<<setw(16)<<setprecision(10)<<a[cc+2];
	  out2<<fixed<<" "<<setw(20)<<setprecision(10)<<a_er[cc+1]<<" "<<setw(20)<<setprecision(10)<<a_er[cc]<<" "<<setw(20)<<setprecision(10)<<a_er[cc+2]<<endl;
      }
      out2<<endl;
      out2.close();   

      free_matrix(covar,1,pik*3,1,pik*3); free_matrix(alpha,1,pik*3,1,pik*3);
      
      wybiel(data, jasnosc_oryg, jasnosc_res, a, pik, ndata);
    }
    
    out3.close();
    
    
    
    delete [] data; delete [] jasnosc_oryg; delete [] jasnosc_res; delete [] blad; delete [] px;
    delete [] py; delete [] a; 
    delete [] ia; 
    delete [] ia1; 
}
